; Spaceship Sprite (non-RLE Compressed) - 5-Apr-2025 by KPK
; Assembler: Acme

!addr zp_src      = $fb
!addr zp_dst      = $fd
!addr offset_dst  = $02a7 ; and $02a8
!addr sprite_base = 160
!addr sprite_addr = sprite_base*64

* = $801
!hex 0b0800009e32303631000000

; ------------------------------------------------------------------------------

start
  jsr clear_sprite_memory
  jsr decompress_sprite_data
  ldy #$00
  ldx #sprite_base
- txa
  sta $7f8,y
  lda sprite_colors,y
  sta $d027,y
  inx
  iny
  cpy #$07
  bne -
  lda #$80
  sta $d000
  sta $d001
  lda #$93
  jsr $ffd2
  lda #$7f
  sta $d015

; ------------------------------------------------------------------------------

loop
  inc $d000
  lda $d000
  sta $d002
  sta $d004
  sta $d006
  sta $d008
  sta $d00a
  sec
  sbc #$05
  sta $d00c
  dec $d001
  lda $d001
  sta $d003
  sta $d005
  sta $d007
  sta $d009
  sta $d00b
  clc
  adc #$0f
  sta $d00d
  lda $a2
  adc #$01
- cmp $a2
  bne -
  and #$03
  bne +
  lda $d015
  eor #$10
  sta $d015
+ jsr $ffe4
  beq loop
  rts

; ------------------------------------------------------------------------------

clear_sprite_memory
  lda #<sprite_addr
  sta zp_dst
  lda #>sprite_addr
  sta zp_dst+1
  ldx #2
  ldy #0
  tya
- sta (zp_dst),y
  iny
  bne -
  inc zp_dst+1
  dex
  bne -
  rts

; ------------------------------------------------------------------------------

decompress_sprite_data  ; data format: qty, offset, values
  lda #<spaceship_sprite_packed
  sta zp_src
  lda #>spaceship_sprite_packed
  sta zp_src+1
  lda #<sprite_addr
  sta zp_dst
  sta offset_dst
  lda #>sprite_addr
  sta zp_dst+1
  sta offset_dst+1

dsd_loop
  ldy #0
  lda (zp_src),y ; qty
  beq dsd_next   ; nothing to get, so skip
  tax            ; set counter to qty
  iny
  lda (zp_src),y ; offset
  clc
  adc zp_dst
  sta zp_dst
  bcc +
  inc zp_dst+1
+ dey
  lda zp_src
  clc
  adc #2
  sta zp_src
  bcc +
  inc zp_src+1
+
- lda (zp_src),y ; values
  sta (zp_dst),y
  iny
  dex
  bne -
  tya            ; prepare to read next set of values
  clc
  adc zp_src
  sta zp_src
  bcc dsd_cont
  inc zp_src+1
dsd_cont
  lda offset_dst ; adjust start of target data
  clc
  adc #64
  sta zp_dst
  sta offset_dst
  bcc +
  inc zp_dst+1
  inc offset_dst+1
+ lda zp_dst+1   ; check for end of data
  cmp #$2b
  bne dsd_loop
  rts

dsd_next
  lda zp_src
  clc
  adc #2
  sta zp_src
  bcc +
  inc zp_src+1
+ jmp dsd_cont

; ------------------------------------------------------------------------------

sprite_colors
!byte $00,$0e,$0c,$02,$07,$01,$0b

spaceship_sprite_packed  ; data format: qty, offset, values
; black components (outline)
!byte 50,0
!byte %........,%....####,%#.......
!byte %........,%..##....,%#.......
!byte %........,%.#......,%#.......
!byte %........,%#.......,%#.......
!byte %.......#,%........,%#.......
!byte %..#####.,%........,%#.......
!byte %.##.....,%.......#,%........
!byte %##......,%.......#,%........
!byte %.#......,%......#.,%........
!byte %..#.....,%.....#..,%........
!byte %..##....,%....#...,%........
!byte %..###...,%...#....,%........
!byte %.#.###..,%...#....,%........
!byte %##..###.,%...#....,%........
!byte %#....###,%...#....,%........
!byte %#...###.,%#.#.....,%........
!byte %#####...,%.#......
; light blue components
!byte 29,18
!byte %...###..,%........,%........
!byte %..####..,%........,%........
!byte %..###...,%#.......,%........
!byte %...#...#,%#.......,%........
!byte %......##,%........,%........
!byte %.....##.,%..#.....,%........
!byte %........,%.##.....,%........
!byte %........,%###.....,%........
!byte %........,%###.....,%........
!byte %........,%.#......
; gray components
!byte 10,13
!byte %..##....,%........
!byte %........,%.####...,%........
!byte %........,%.####...,%........
!byte %........,%..##....
; red components
!byte 42,4
!byte %....####,%........
!byte %........,%.....###,%........
!byte %........,%......##,%........
!byte %........,%.......#,%........
!byte %........,%........,%........
!byte %........,%........,%........
!byte %........,%........,%........
!byte %........,%........,%........
!byte %........,%........,%........
!byte %........,%........,%........
!byte %........,%........,%........
!byte %..#.....,%........,%........
!byte %........,%........,%........
!byte %.#..#...,%........,%........
!byte %.###....
; yellow components
!byte 4,39
!byte %..##....,%........,%........
!byte %..##....
; white components
!byte 33,7
!byte %..###...,%........
!byte %........,%.#####..,%........
!byte %........,%##..###.,%........
!byte %.......#,%#....###,%........
!byte %......##,%#....##.,%........
!byte %......##,%##..###.,%........
!byte %.....###,%.#####..,%........
!byte %....###.,%.####...,%........
!byte %....##..,%####....,%........
!byte %.......#,%##......,%........
!byte %......##,%#.......,%........
!byte %.......#
; trailing smoke
!byte 19,0
!byte %...#....,%........,%........
!byte %..#.....,%........,%........
!byte %.#......,%........,%........
!byte %#..#..#.,%........,%........
!byte %..#..#..,%........,%........
!byte %.#..#...,%........,%........
!byte %#..#....,%........,%........